    vec2 getSunRotationData() {
        return vec2(cos(sunPathRotation * 0.01745329251994), -sin(sunPathRotation * 0.01745329251994));
    }

    vec3 getUsunvec(vec2 sunRotationData) {
        float ang = fract(timeAngle - 0.25);
        ang = (ang + (cos(ang * PI) * -0.5 + 0.5 - ang) * 0.333) * TAU;
        return vec3(-sin(ang), cos(ang) * sunRotationData.x, cos(ang) * sunRotationData.y);
    }

    vec3 getNormalizedUpVec() {
        vec3 upVec = normalize(gbufferModelView[1].xyz);
        return upVec;
    }

    vec3 getNormalizedEastVec() {
        vec3 eastVec = normalize(gbufferModelView[0].xyz);
        return eastVec;
    }

    vec3 getSunVec(vec3 uSunVec, vec2 sunRotationData) {
    #if defined (OVERWORLD)
        return normalize((gbufferModelView * vec4(uSunVec * 2000.0, 1.0)).xyz);
    #elif defined (END)
        return normalize((gbufferModelView * vec4(vec3(0.0, sunRotationData * 2000.0), 1.0)).xyz);
    #else
        return vec3(0.0);
    #endif
    }